# Creating a new test case

The following things must be done:

- Create a new directory in `src/test/01-input` and put at least grammar, the ros2rag-specification and a README.md in there. Optionally, aspect files as needed.
- Optionally, add new protobuf definitions in `src/test/proto` (they are processed automatically in this directory)
- Copy and modify the compiler instructions in `build.gradle`, e.g. `preprocessExampleTest` and `compileExampleTest` for the `example` case. Also, copy the dependsOn-Definitions.
    - Change the name of the tasks
    - Change the directory in `delete` spec, and in all arguments
    - Add/Remove aspect files
    - Change the `packageName` argument in the compile-step
    - Change the `--rootNode` argument in the preprocess-step
    - For debugging build problems, the `--verbose` flag in the preprocess-step can be helpful
- Create the test case itself in `src/test/java/` in the package `org.jastadd.ros2rag.tests` and import the AST files of your defined target generation package
    - Extend the abstract base class `AbstractMqttTest` to have fail-fast-behaviour in case the MQTT-broker is not connected
    - Remember to close all used MQTT-handling objects, like MqttHandler and the model itself after each test
